# http://www.AdCycle.com - AdCycle Version 1.27  Jan 01, 2009
# Copyright (c) 2009 AdCycle.com All rights reserved.


#  THIS SOFTWARE IS NO LONGER SUPPORTED, USE AT YOUR OWN RISK!


# -- SOFTWARE AGREEMENT >>
# Version 1.27 is free software. You are hereby licensed to use version 1.27 of this software for 
# evaluation purposes. You must agree to the following before using AdCycle.
#
# 1. Future AdCycle versions may not be free.
#
# 2. All copyrights to AdCycle are exclusively owned by the author.
#
# 3. AdCycle may be freely distributed, provided the distribution package 
#    is not modified. No person or company may charge a fee for the distribution 
#    of AdCycle without written permission from AdCycle.
#
# 4. You may not use, copy, emulate, clone, rent, lease, sell, modify, 
#    disassemble, otherwise reverse engineer, or transfer this program 
#    program, or any subset of the licensed program, except as provided for 
#    in this agreement. You can modify the look and feel of AdCycle and make
#    code changes for your own use only, provided that all copyright notices and 
#    links remain intact and each modified installation is regitered. Any 
#    unauthorized use shall result in immediate and automatic termination of 
#    this agreement and may result in criminal and/or civil prosecution. All rights
#    not expressly granted here are reserved by author.
#
# 5. Charting capability has been provided by ObjectPlanet.com. You may only use 
#    the EasyCharts applet for AdCycle reporting.
#
# 6. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
#    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
#    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
#    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
#    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
#    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
#    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
#    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
#    OF THE POSSIBILITY OF SUCH DAMAGE.
#
# 7. Installing and using AdCycle signifies acceptance of this agreement.
#
# 8. If you do not agree with the terms of this agreement you must remove AdCycle 
#    files from your storage devices and cease to use the product.
#
# -- SOFTWARE AGREEMENT <<






################################################################
####          AdCycle Configuration (AdConfig.pm)           ####
################################################################

package AdConfig;
use strict;
use vars '$AUTOLOAD';


sub AUTOLOAD{
	my ($self) = @_;
	$AUTOLOAD =~ /.*::get(_\w+)/;
	exists $self->{$1};
	return $self->{$1}	# return attribute
}



sub initialize {
	my $self = shift;

#############################################
# *** OPTIONS 1-7  REQUIRE MODIFICATION *** #
#############################################

 #-- 1. ADCYCLE ADMIN USER NAME
 $self->{_admin_user_name}  ="admin";    #<<<<-- admin user name

 #-- 2. ADCYCLE ADMIN PASSWORD
 $self->{_admin_password}="";    #<<<<-- admin password 

 #-- 3. URL OF ADCYCLE CGI-BIN DIRETORY
 $self->{_cgi_bin_url}="http://www.your_site.com/cgi-bin/adcycle";   #<<<<-- leave out trailing "/"
						
 #-- 4. URL OF ADCYCLE IMAGES DIRECTORY (ALSO CONTAINS TOOLBAR SCRIPT)
 $self->{_images_url}="http://www.your_site.com/adimages";     #<<<<-- leave out trailing "/"


###############################
# ----   MySQL Settings   --- #

 #-- 5. MySQL USER NAME (permissions must be set in MySQL for this name)
 $self->{_db_user}->{adcycle}="mysql_user_name";    #<<<<-- MySQL database user

 #-- 6. MySQL PASSWORD (permissions must be set in MySQL for this password)
 $self->{_db_password}->{adcycle}="mysql_password";    #<<<<-- MySQL database user password

 #-- 7. MySQL DATABASE NAME
 $self->{_db_database}->{adcycle}="adcycle"; #<<<<-- MySQL database name

 #-- 8. MySQL IP/Domain Name(necessary in some cases)
 $self->{_db_ip}->{adcycle}="";    #<<<<--optional ip/domain (usually leave as-is)

# ---- End MySQL Settings --- #
###############################


 #-- 9. Apache DBI Enabled
 $self->{_apache_dbi}->{adcycle}="no";    #<<<<--(yes or no) (usually leave as-is)

 #-- 10. DHTML Navigation Menu
 $self->{_dhtml_menu}="yes";    #<<<<--(yes or no) (usually leave as-is)


}
#  - Consult with your ISP for MySQL options
#  - Don't forget to create a mySQL database consistent with item 5,6 & 7
#  - Don't forget set mySQL permissions consistent with 5,6 (may not be required)
#  - No other mods should be required for this file
###################################################################
####                  End Installation Notes                   ####
###################################################################

sub new {
	my $this = shift;
	my $class = ref($this) || $this;
	my $self = {};
	bless $self, $class;
  $self->initialize();
	return $self;
}

1;
