# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.adcycle.com - download the lastest version of adcycle 

package AdManager;
use strict;


sub new {
	my $this = shift;
	my $class = ref($this) || $this;
	my $self = {};
	bless $self, $class;
	return $self;
}


# >> view adtypes
sub view_adtypes{
	my($self,$master)=@_;

	
	# get config and env vars
	my $images_url=$master->{config}->get_images_url;
	my $cgi_bin_url=$master->{config}->get_cgi_bin_url;
	my $cache=$master->{env}->get_cache;
	
	
	# print header
	$master->{LINK}="groups";
	$master->{html}->header($master,"Ad Types");


	#get the groups
	my (@tidref)=$master->{db}->select_multi_row_hash("SELECT * FROM adtype order by WIDTH");
	my $tidtot=@tidref;


	print qq~
	<img src="$images_url/clear.gif" width=1 height=15><br>
	<table cellpadding=4 cellspacing=1 border=0 bgcolor="333333">
	<tr class="td2">
	<td align="center"><b>Ad Type Name</td>
	<td align="center"><b>Width</td>
	<td align="center"><b>Height</td>
	<td align="center"><b>Default Image URL</td>
	<td align="center"><b>Default Click URL</td>
	<td align="center"><b>&nbsp;</td>
	</tr>
	~;

	my $coo;

	for(my $k=0;$k<$tidtot;$k++){

		my $color="td3";
		if($coo==1){
			$color="td5";
			$coo=0;
		}else{
			$coo++;	
		}


		$tidref[$k]->{DEFAULT_IMAGE}=$master->{tools}->trim("40",$tidref[$k]->{DEFAULT_IMAGE});
		$tidref[$k]->{DEFAULT_CLICK}=$master->{tools}->trim("40",$tidref[$k]->{DEFAULT_CLICK});

		if($tidref[$k]->{WIDTH}<10 || $tidref[$k]->{HEIGHT}<10){
			$tidref[$k]->{WIDTH}="<font color=999999>N/A";
			$tidref[$k]->{HEIGHT}="<font color=999999>N/A";
		}

		print qq~
		<tr class="$color">
		<td><b>&nbsp;$tidref[$k]->{NAME}</td>
		<td align="center">$tidref[$k]->{WIDTH}</td>
		<td align="center">$tidref[$k]->{HEIGHT}</td>
		<td align="right">$tidref[$k]->{DEFAULT_IMAGE}</td>
		<td align="center">$tidref[$k]->{DEFAULT_CLICK}</td>
		<td align="center"><a href="$cgi_bin_url/adcenter.cgi?task=edit_adtype&tid=$tidref[$k]->{TID}&cache=$cache">Edit</a> |
				<a href="$cgi_bin_url/adcenter.cgi?task=view_adtype_history&tid=$tidref[$k]->{TID}&cache=$cache">Stats</a>
		</td>
		</td>
		</tr>
		~;
	}

	print qq~
	</table>
	&nbsp;<br>
	&nbsp;<br>
	~;



	# add adtype form
	print qq~
	<form action="$cgi_bin_url/adcenter.cgi" method="post">
	<table cellpadding=4 cellspacing=1 border=0 bgcolor="333333">

	<tr class="td2">
	<td colspan=2><b>Create a New Ad Type</b></td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Description:</td>
	<td><input type="text" name="name" value="" size="$master->{medium}" class="ft1"></td>
	</tr>
		
	<tr class="td3">
	<td align="right"><b>Geometry:</td>
	<td><input type="text" name="width" value="" size="$master->{shortest}" class="ft1"> <b>x</b> <input type="text" name="height" value="" size="$master->{shortest}" class="ft1"> pixels</td>
	</tr>




	</table>
	<img src="$images_url/clear.gif" width=1 height=5><br>
	<input type="hidden" name="task" value="add_adtype">
	<input type="submit" name="change" value="ADD" class="ft2">
	<input type="hidden" name="cache" value="$cache">
	</form>
	~;



	$master->{html}->footer($master);
}
# << view adtypes













sub view_manager{
	my($self,$master)=@_;

	# get config and env vars
	my $images_url=$master->{config}->get_images_url;
	my $cgi_bin_url=$master->{config}->get_cgi_bin_url;
	my $cache=$master->{env}->get_cache;
	

	#get the campaigns
	my $configref=$master->{db}->select_single_row_hash("SELECT * FROM adconfig");	

	# print header
	$master->{LINK}="manager";
	$master->{html}->header($master,"Adcycle Manager");

	if($master->{query}->param('uid')==0){
		print $master->{image}."<br>";
	}


	# checkboxes
	my %cron; if($configref->{CRON_ENABLED}==1){$cron{1}=" checked ";};
	my %earn; if($configref->{DISPLAY_EARNINGS}==1){$earn{1}=" checked ";};
	my %delay; if($configref->{DELAYED_INSERT}==1){$delay{1}=" checked ";};
	my %ad;if($configref->{DISPLAY_ADVERTISER}==1){$ad{1}=" checked ";};
	my %auto;if($configref->{AUTO_ACTIVATE}==1){$auto{1}=" checked ";};
	my %drill;if($configref->{DRILL}==1){$drill{1}=" checked ";};


	# add campaign form
	print qq~
	<form action="$cgi_bin_url/adcenter.cgi" method="post">

	<img src="$images_url/clear.gif" width=1 height=15><br>
	<table cellpadding=4 cellspacing=1 border=0 bgcolor="333333">
	<tr class="td2">
	<td colspan=2><b>&nbsp;AdCycle Setup &nbsp;&nbsp;~;print $master->{html}->question("manager");print qq~</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Earnings Display:</td>
	<td><input type="checkbox" $earn{1} name="earn" value="1" class="ft3"> Display earnings on the campaigns page</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Delayed Insert:</td>
	<td><input type="checkbox" $delay{1} name="delay" value="1" class="ft3"> Use MySQL delayed insert</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Cron Enabled:</td>
	<td><input type="checkbox" $cron{1} name="cron" value="1" class="ft3"> Cron activated for background tasks</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Advertiser Display:</td>
	<td><input type="checkbox" $ad{1} name="ad" value="1" class="ft3"> Display advertisers on the campaigns page</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Auto-Activate:</td>
	<td><input type="checkbox" $auto{1} name="auto" value="1" class="ft3"> Auto-activate campaigns within a group</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Toolbar Drilldown:</td>
	<td><input type="checkbox" $drill{1} name="drill" value="1" class="ft3"> Enable toolbar drilldown</td>
	</tr>


	<tr class="td3">
	<td align="right"><b>P3P Header:</td>
	<td><input type="text" name="p3p" value="$configref->{P3P}" size="$master->{long}" class="ft3"> (optional)</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Ad Folder Path:</td>
	<td><input type="text" name="ad_path" value="$configref->{AD_DIR}" size="$master->{long}" class="ft3"> (optional)</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Ad Folder URL:</td>
	<td><input type="text" name="ad_url" value="$configref->{AD_URL}" size="$master->{long}" class="ft3"> (optional)</td>
	</tr>

	<tr class="td3">
	<td align="right"><b>Ad Types:</td>
	<td><a href="$cgi_bin_url/adcenter.cgi?task=view_adtypes&cache=$cache">Edit</a></td>
	</tr>


	</table>
	<img src="$images_url/clear.gif" width=1 height=5><br>
	<input type="hidden" name="task" value="update_adcycle_variables">
	<input type="submit" name="change" value="UPDATE" class="ft2">
	<input type="hidden" name="cache" value="$cache">
	</form>
	&nbsp;<br>
	~;


	$master->{html}->footer($master);
}




# >> add adtype
sub add_adtype{
  my($self,$master)=@_;

	# input params
	my $name=$master->{query}->param('name')."";
	my $width=$master->{query}->param('width')+0;
	my $height=$master->{query}->param('height')+0;

	my $tempref=$master->{db}->select_single_row_hash("SELECT * FROM adtype WHERE WIDTH=$width AND HEIGHT=$height");

	if(!$tempref){
	my $tid=$master->{tools}->get_id($master,"TID");
	# make insert list
	my $insert_list=[
   ["TID",$tid],
   ["NAME",$name],
   ["WIDTH",$width],
   ["HEIGHT",$height]
	];
	# insert row
	$master->{db}->insert_row("adtype",$insert_list);
	}

	$master->{message}="AdType has been added";
	$master->{manager}->view_manager($master);
}
# << add adtype


# >> adcycle variables
sub update_adcycle_variables{
  my($self,$master)=@_;

	# input params
	my $cron=$master->{query}->param('cron')+0;
	my $earn=$master->{query}->param('earn')+0;
	my $delay=$master->{query}->param('delay')+0;
	my $ad=$master->{query}->param('ad')+0;
	my $auto=$master->{query}->param('auto')+0;
	my $clear=$master->{query}->param('clear')+0;
	my $ad_path=$master->{query}->param('ad_path')."";
	my $ad_url=$master->{query}->param('ad_url')."";
	my $p3p=$master->{query}->param('p3p')."";
	my $drill=$master->{query}->param('drill')+0;

	$master->{db}->{adcycle}->do("ALTER TABLE adconfig MODIFY AD_DIR VARCHAR(200) NOT NULL DEFAULT ''");

	# generate query list
	my $c;
	$c=$master->{db}->update_cv($c,"CRON_ENABLED",$cron);
	$c=$master->{db}->update_cv($c,"DELAYED_INSERT",$delay);
	$c=$master->{db}->update_cv($c,"DISPLAY_ADVERTISER",$ad);
	$c=$master->{db}->update_cv($c,"DISPLAY_EARNINGS",$earn);
	$c=$master->{db}->update_cv($c,"AUTO_ACTIVATE",$auto);
	$c=$master->{db}->update_cv($c,"AD_DIR",$ad_path);
	$c=$master->{db}->update_cv($c,"AD_URL",$ad_url);
	$c=$master->{db}->update_cv($c,"DRILL",$drill);
	$c=$master->{db}->update_cv($c,"P3P",$p3p);
	chop($c);

	# insert row
	$master->{db}->{adcycle}->do("UPDATE adconfig SET $c");

	$master->{message}="AdCycle Manager has been updated ";
	$master->{manager}->view_manager($master);
}
# << adcycle variables






# >> edit adtype
sub edit_adtype{
	my($self,$master)=@_;

	
	# get config and env vars
	my $images_url=$master->{config}->get_images_url;
	my $cgi_bin_url=$master->{config}->get_cgi_bin_url;
	my $cache=$master->{env}->get_cache;
	
	# input vars
	my $aid=$master->{query}->param('aid');
	my $tid=$master->{query}->param('tid');

	
	# print header
	$master->{LINK}="manager";
	$master->{html}->header($master,"Manager");


	#get the campaigns
	my $tidref=$master->{db}->select_single_row_hash("SELECT * FROM adtype where TID='$tid'");

	# >> geomtery
	my $geometry=qq~$tidref->{WIDTH} x $tidref->{HEIGHT} pixels~;
	if($tidref->{WIDTH}==1 && $tidref->{HEIGHT}==1){
		$geometry="Text Links";
	}
	if($tidref->{WIDTH}==2 && $tidref->{HEIGHT}==2){
		$geometry="Pop Windows";
	}
	# << geometry


	# >> top menu
	print qq~
	<div class="font1">
	<a href="$cgi_bin_url/adcenter.cgi?task=view_adtypes&cache=$cache">View Ad Types</a> : 
	Edit $tidref->{NAME}
	</div>
	~;
	# << top menu	



	print qq~
	&nbsp;<br>
	<form action="$cgi_bin_url/adcenter.cgi" method="post">
	<table cellpadding=4 cellspacing=1 border=0 bgcolor="333333">

	<tr class="td2">
	<td colspan=2><b>Edit Ad Type Information</b></td>
	</tr>


	<tr class="td3">
	<td align="right">&nbsp;<b>Description:</td>
	<td><input type="text" name="name" value="$tidref->{NAME}" size=$master->{medium} class="ft1"></td>
	</tr>

	<tr class="td3">
	<td align="right">&nbsp;<b>Geometry:</td>
	<td>$geometry</td>
	</tr>
	~;



	if(($tidref->{WIDTH}!=1 && $tidref->{HEIGHT}!=1)&&($tidref->{WIDTH}!=2 && $tidref->{HEIGHT}!=2)){
		print qq~
		<tr class="td3">
		<td align="right">&nbsp;<b>Default Image URL:</td>
		<td><input type="text" name="default_image" value="$tidref->{DEFAULT_IMAGE}" size=$master->{long} class="ft1"></td>
		</tr>
		~;
	}
	


	print qq~
	<tr class="td3">
	<td align="right">&nbsp;<b>Default Click URL:</td>
	<td><input type="text" name="default_click" value="$tidref->{DEFAULT_CLICK}" size=$master->{long} class="ft1"></td>
	</tr>



	</table>
	<img src="$images_url/clear.gif" width=1 height=5><br>


	<input type="hidden" name="tid" value="$tid">
	<input type="hidden" name="task" value="update_adtype">
	<input type="submit" name="change" value="UPDATE" class="ft2">
	<input type="hidden" name="cache" value="$cache">
	</form>
	&nbsp;<br>
	~;


	if(($tidref->{WIDTH}!=1 && $tidref->{HEIGHT}!=1)&&($tidref->{WIDTH}!=2 && $tidref->{HEIGHT}!=2)){
		print qq~
		<b><a href="$cgi_bin_url/adcenter.cgi?task=delete_adtype&tid=$tid&cache=$cache">Delete this ad type</a>
		~;
	}

	$master->{html}->footer($master);
}
# >> edit adtype





# >> delete ad types
sub delete_adtype{
  my($self,$master)=@_;

	# input params
	my $tid=$master->{query}->param('tid');

	

	# insert row
	my $cp_qty=$master->{db}->single_result("SELECT COUNT(*) from cp WHERE TID='$tid'");

	if($cp_qty==0){
		$master->{db}->{adcycle}->do("DELETE FROM adtype WHERE TID='$tid'");
		$master->{message}="AdType has been DELETED";
	}else{
		$master->{message}="NOT DELETED. You must first delete all campaigns that are using this ad type proir to deleting!";
	}

	$master->{manager}->view_manager($master);
}
# << update ad types




# >> update ad types
sub update_adtype{
  my($self,$master)=@_;

	# input params
	my $tid=$master->{query}->param('tid');
	my $name=$master->{query}->param('name')."";
	my $default_image=$master->{query}->param('default_image')."";
	my $default_click=$master->{query}->param('default_click')."";

	# generate query list
	my $c;
	$c=$master->{db}->update_cv($c,"NAME",$name);
	$c=$master->{db}->update_cv($c,"DEFAULT_IMAGE",$default_image);
	$c=$master->{db}->update_cv($c,"DEFAULT_CLICK",$default_click);
	chop($c);

	# insert row
	$master->{db}->{adcycle}->do("UPDATE adtype SET $c WHERE TID='$tid'");

	$master->{message}="AdType has been updated";
	$master->{manager}->edit_adtype($master);
}
# << update ad types






sub logout{
  my($self,$master)=@_;

	# config and env vars
	my $images_url=$master->{config}->get_images_url;
	my $cgi_bin_url=$master->{config}->get_cgi_bin_url;
	my $cache=$master->{env}->get_cache;
	my $remote=$master->{env}->get_remote;

	# get cookie info
	my $login_cookie=$master->{query}->cookie('ADCYCLE_LOGIN');
	my ($ck_login,$ck_id)=split(/\|/,$login_cookie);

	# delete grouping
	$master->{db}->{adcycle}->do("DELETE FROM login WHERE ACCOUNT='$ck_login' OR REMOTE='$remote'");
	$master->{hide_toolbar}="yes";

	$master->{html}->login($master);
}


# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.adcycle.com - download the lastest version of adcycle 

1;

