#!/usr/bin/perl

# ******* Update the header "#!/usr/bin/perl" to point to perl on your system *******
# ******* In most cases the default will work.                                *******
# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.adcycle.com - download the lastest version of adcycle


use strict;
use AdMaster;
my $master=AdMaster->new();
$master->{db}->connect($master,"adcycle");
$master->{login}->check_login($master);
$master->{adconfig}=$master->{db}->select_single_row_hash("SELECT * FROM adconfig");	

if($master->{whoami} eq "ADMIN"){

	# GROUPS
	my $task=$master->{query}->param('task');
	if($task eq "view_groups"){$master->{groups}->view_groups($master);}
	if($task eq "edit_group"){$master->{groups}->edit_group($master);}
	if($task eq "update_group"){$master->{groups}->update_group($master);}
	if($task eq "delete_group"){$master->{groups}->delete_group($master);}
	if($task eq "add_group"){$master->{groups}->add_group($master);}
	if($task eq "add_group_form"){$master->{groups}->add_group_form($master);}
	if($task eq "get_adcodes"){$master->{groups}->get_adcodes($master);}


	# ADVERTISERS
	if($task eq "view_advertisers"){$master->{advertiser}->view_advertisers($master);}
	if($task eq "edit_advertiser"){$master->{advertiser}->edit_advertiser($master);}
	if($task eq "update_advertiser"){$master->{advertiser}->update_advertiser($master);}
	if($task eq "add_advertiser"){$master->{advertiser}->add_advertiser($master);}
	if($task eq "add_advertiser_form"){$master->{advertiser}->add_advertiser_form($master);}
	if($task eq "delete_advertiser"){$master->{advertiser}->delete_advertiser($master);}


	# CAMPAIGNS
	if(length($task) < 2 || $task eq "view_campaigns"){$master->{campaign}->view_campaigns($master);}
	if($task eq "edit_campaign"){$master->{campaign}->edit_campaign($master);}
	if($task eq "add_campaign"){$master->{campaign}->add_campaign($master);}
	if($task eq "delete_campaign"){$master->{campaign}->delete_campaign($master);}
	if($task eq "select_campaign_groups"){$master->{campaign}->select_campaign_groups($master);}
	if($task eq "update_campaign_grouping"){$master->{campaign}->update_campaign_grouping($master);}
	if($task eq "update_campaign"){$master->{campaign}->update_campaign($master);}
	if($task eq "update_advanced_campaign"){$master->{campaign}->update_advanced_campaign($master);}
	if($task eq "delete_media"){$master->{campaign}->delete_media($master);}
	if($task eq "add_standard"){$master->{campaign}->add_standard($master);}
	if($task eq "update_standard"){$master->{campaign}->update_standard($master);}
	if($task eq "add_html"){$master->{campaign}->add_html($master);}
	if($task eq "update_html"){$master->{campaign}->update_html($master);}
	if($task eq "edit_standard"){$master->{campaign}->edit_standard($master);}
	if($task eq "edit_html"){$master->{campaign}->edit_html($master);}
	if($task eq "reset_media"){$master->{campaign}->reset_media($master);}
	if($task eq "add_campaign_form"){$master->{campaign}->add_campaign_form($master);}
	if($task eq "delivery_rate"){$master->{campaign}->delivery_rate($master);}
	if($task eq "direct_adcode"){$master->{campaign}->direct_adcode($master);}
	if($task eq "reset_campaign_data"){$master->{campaign}->reset_campaign_data($master);}


	# TARGET
	if($task eq "edit_targeting"){$master->{target}->edit_targeting($master);}
	if($task eq "add_target"){$master->{target}->add_target($master);}
	if($task eq "update_targeting"){$master->{target}->update_targeting($master);}
	if($task eq "delete_targeting"){$master->{target}->delete_targeting($master);}


	# MANAGER
	if($task eq "logout"){$master->{manager}->logout($master);}
	if($task eq "view_manager"){$master->{manager}->view_manager($master);}
	if($task eq "update_manager"){$master->{manager}->update_manager($master);}
	if($task eq "update_adcycle_variables"){$master->{manager}->update_adcycle_variables($master);}
	if($task eq "add_adtype"){$master->{manager}->add_adtype($master);}
	if($task eq "edit_adtype"){$master->{manager}->edit_adtype($master);}
	if($task eq "view_adtypes"){$master->{manager}->view_adtypes($master);}
	if($task eq "update_adtype"){$master->{manager}->update_adtype($master);}
	if($task eq "delete_adtype"){$master->{manager}->delete_adtype($master);}

	# REPORTS
	if($task eq "campaign_history"){$master->{reports}->campaign_history($master);}
	if($task eq "view_campaign_history"){$master->{reports}->view_campaign_history($master);}
	if($task eq "view_group_history"){$master->{reports}->view_group_history($master);}
	if($task eq "view_adtype_history"){$master->{reports}->view_adtype_history($master);}

}else{

	# advertiser login
	my $task=$master->{query}->param('task');
	if(length($master->{whoami})>0){
		# MANAGER
		if($task eq "logout"){$master->{manager}->logout($master);}
		if(length($task) < 2 || $task eq "campaigns"){$master->{reports}->campaigns($master);}
		if($task eq "campaign_report"){$master->{reports}->campaign_report($master);}
		if($task eq "view_campaign_history"){$master->{reports}->view_campaign_history($master);}
		if($task eq "campaign_history"){$master->{reports}->campaign_history($master);}
	}else{
		$master->{html}->login($master);
	}

}

if($master->{header} ne "yes"){
	$master->{html}->login($master);
}

$master->{db}->clean_up($master);
exit(0);


# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.AdCycle.com
