#!/usr/bin/perl

# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.adcycle.com - download the lastest version of adcycle

# ******* Update the header "#!/usr/bin/perl" to point to perl on your system *******
# ******* In most cases the default will work.                                *******


use strict;
use AdConfig;
use AdEnv;
use AdDb;
use AdCron;
use AdCookies;
use CGI;

my $master;
$master->{config}=AdConfig->new();
$master->{env}=AdEnv->new();
$master->{db}=AdDb->new;
$master->{cron}=AdCron->new;
$master->{cookie}=AdCookies->new;
$master->{query}=CGI->new;
$master->{db}->connect($master,"adcycle");
$master->{debugger}="off";


# input parameters
my $cid=0;
my $cid=$master->{query}->param('cid')+0;
my $mid=$master->{query}->param('mid')+0;
my $gid=$master->{query}->param('gid')+0;
my $layout=$master->{query}->param('layout')+0;
my $id=$master->{query}->param('id')."";


# config and env vars
my $cgi_bin_url=$master->{config}->get_cgi_bin_url;
my $remote=$master->{env}->get_remote;
my $agent=$master->{env}->get_agent;
my $hour=$master->{env}->get_hour;
my $page_url=$master->{env}->get_refer;
my $datestamp=$master->{env}->get_datestamp;
my $timestamp=$master->{env}->get_timestamp;
my $images_url=$master->{config}->get_images_url;
my $output="";


# define defaults
my $cookie_depth=20;
$master->{COOKIE_DEPTH}=$cookie_depth;
if($gid==0){$gid=1;}
if($id==0){$id=1;}
$master->{GID}=$gid;
$master->{ID}=$id;
$master->{layout}=$layout;


# >> get the group ref + cookie
my $gidref=$master->{db}->select_single_row_hash("SELECT * FROM groups where GID='$gid'");
$master->{gidref}=$gidref;
my $width=$gidref->{WIDTH};
my $height=$gidref->{HEIGHT};
my $tid=$gidref->{TID};
$master->{TID}=$tid;
my $impr_cookie=$master->{query}->cookie("i$tid");
my $click_cookie=$master->{query}->cookie("c$tid");
# << get the group ref + cookie


$master->{impr_cookie}=$impr_cookie;
$master->{click_cookie}=$click_cookie;
$master->{remote}=$remote;
$master->{timestamp}=$timestamp;



# get unix stamp
$master->{UNIX_STAMP}=$master->{db}->single_result("SELECT UNIX_TIMESTAMP('$timestamp')");


# >> locate from cookies
if($cid==0){
	($cid,$mid)=$master->{cookie}->find_cookie_match($master);
}
# << locate from cookies



# >> locate from live_log
if($cid==0){
	my $live_ref=$master->{db}->select_single_row_hash("SELECT * FROM dlog$hour WHERE IP='$remote' AND GID='$gid' AND CACHE='$id' ORDER BY STAMP DESC");
	if(!$live_ref){
		my $old_hour=$master->{db}->single_result("SELECT HOUR(DATE_ADD('$datestamp',INTERVAL -1 HOUR))");
		$live_ref=$master->{db}->select_single_row_hash("SELECT * FROM dlog$old_hour WHERE IP='$remote' AND GID='$gid' AND CACHE='$id' ORDER BY STAMP DESC");
	}
	$cid=$live_ref->{CID};
	$mid=$live_ref->{MID};
}
# << locate from live_log



# >> campaign found
if($cid>0 && $mid>0 && $gidref){

	my $cidref=$master->{db}->select_single_row_hash("SELECT * FROM cp WHERE CID='$cid'");
	my $midref=$master->{db}->select_single_row_hash("SELECT * FROM cp_media WHERE MID='$mid'");
	$master->{CID}=$cid;
	$master->{MID}=$mid;

	# click check
	$master=$master->{cookie}->click_check($master,$cidref);

	if($master->{GOOD_CLICK} eq "yes"){

		# >> update database files
		$master->{db}->{adcycle}->do("UPDATE cp_grouping SET HOUR_CLICK=HOUR_CLICK+1,TOTAL_CLICK=TOTAL_CLICK+1 WHERE GID='$gid' AND CID='$cid' AND MID='$mid'");
		$master->{db}->{adcycle}->do("UPDATE cp_media SET TOTAL_CLICK=TOTAL_CLICK+1 WHERE MID='$mid'");
		$master->{db}->{adcycle}->do("UPDATE cp SET CLICK_BIN=CLICK_BIN-1,DELIVERED_CLICK=DELIVERED_CLICK+1,TODAY_CLICK=TODAY_CLICK+1 WHERE CID='$cid'");
		my $insert_list=[["IP",$remote],["CID",$cid],["GID",$gid],["MID",$mid],["ACTION","1"],["AGENT",$agent],["PAGE_URL",$page_url],["CACHE",$id]];
		$master->{db}->insert_row("dlog$hour",$insert_list);
		# << end update database files


	# >> raw_logging [turn from "off" to "on" to enable]
	my $logging="off";
	my $log_dir="/path/to/log/dir";
	my $event_type="C";

	if($logging eq "on"){
		# more load! - comment out fields you don't need
		my $cidref=$master->{db}->select_single_row_hash("SELECT * FROM cp where CID='$cid'");
		my $aidref=$master->{db}->select_single_row_hash("SELECT * FROM ad where AID='$cidref->{AID}'");
		my $midref=$master->{db}->select_single_row_hash("SELECT * FROM cp_media where MID='$mid'");
		my $list.="$event_type|"; # event type
		$list.="$remote|"; # IP
		$list.="$cidref->{AID}|"; # ADVERTISER ID
		# $list.="$aidref->{ADVERTISER_NAME}|"; # ADVERTISER NAME
		$list.="$cid|"; # CAMPAIGN ID
		# $list.="$cidref->{CAMPAIGN_NAME}|"; # CAMPAIGN NAME
		$list.="$gid|"; # GID
		# $list.="$gidref->{GROUP_NAME}|"; # GROUP NAME
		$list.="$mid|"; # MID
		#	$list.="$midref->{NAME}|"; # MEDIA NAME
		$list.="$agent|"; # BROWSER TYPE
		$list.="$page_url|"; # PAGE URL
		$list.="$datestamp|"; # DATESTAMP
		open(W,">> $log_dir/raw.log");
		print W "$list\n";
		close(W);
	}
	# << raw_logging

	}

	# output click cookie
	$master->{cookie}->output_click_cookie($master,$cidref);
	print $master->{click_cookie};

	$midref->{CLICK_URL}=~s/IDNUMBER+/$id/g;
	$output=qq~Location: $midref->{CLICK_URL}\n\n~;

}else{
	if($tid+0==0){
		$tid=1;
	}
	my $tidref=$master->{db}->select_single_row_hash("SELECT * FROM adtype WHERE TID=$tid");
	$output=qq~Location: $tidref->{DEFAULT_CLICK}\n\n~;
}
#<< campaign found

print $output;

$master->{db}->clean_up($master);
exit(0);


# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.adcycle.com - download the lastest version of adcycle cle 