#!/usr/bin/perl


# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.adcycle.com - download the lastest version of adcycle

# build.cgi - checks your configuration and builds the tables for adcycle


use strict;
use AdMaster;
my $master=AdMaster->new("query");


# get config and env vars
my $cgi_bin_url=$master->{config}->get_cgi_bin_url;
my $images_url=$master->{config}->get_images_url;
my $date=$master->{env}->get_date;

# global vars
my $sth;
my @log;

print "Content-type: text/html\n\n";
print "<pre>";
print "\n>>>\n";
print ">>>>>>>\n";
print ">>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n";
print ">>   START BUILDING ADCYCLE    >>\n";

#### PERL CHECK  ####
print "\n\nStep 1 - Checking for Perl\n\n";
eval "require 5.003";
if ($@) {print "Please use Perl 5.003 or greater.\n\n";exit(0);}
print " >> Great! Perl was found\n";
#### PERL CHECK  ####



#### DBI CHECK  ####
print "\n\nStep 2 - Checking for DBI.\n\n";
eval "use DBI";
if ($@){
	print "DBI module could not be located. Please download it from the URL in the README file.";
	exit(0);
}
print " >> Today must be a good one. DBI was found\n";
#### DBI CHECK  ####



#### MYSQL DRIVER CHECK  ####
print "\n\nStep 3 - mySQL driver check\n\n";
my $myfound=0;
my @mysqldrivers=DBI ->available_drivers;
my $dat=@mysqldrivers;
for (my $k=0;$k<$dat;$k++){
	if(index($mysqldrivers[$k],"mysql")!=-1){
		$myfound=1;
	}
}
if($myfound!=1){
	print "mySQL driver was not found. Please download it from the URL in the README file.\n\n";
	exit(0);
}
print " >> Almost finished.... mySQL driver was found\n";
#### MYSQL DRIVER CHECK  ####



#### CONNECT TO MYSQL ####
print "\n\nStep 4 - Trying to connect to database. \n\n";
print "      ** If you don't see the message \"Database was found!\", please check to see if you have\n";
print "      ** created a database called \"$master->{config}->{_db_database}->{adcycle}\" and have the permissions properly set.\n";
print "      ** Contact your ISP for MySQL help if you get error messages.\n\n";
$master->{db}->connect($master,"adcycle");
my $DB_found="NO";
$sth = $master->{db}->{adcycle}->prepare("show databases"); 
$sth->execute;
while(@log = $sth->fetchrow_array){
	if($log[0] eq $master->{config}->{_db_database}->{adcycle}){
		$DB_found="YES";
	}
}
if($DB_found eq "NO"){
	print "Your database was not found. Please check to see if you have created a database called 
	\"$master->{config}->{_db_database}->{adcycle}\", or check to see if MySQL permissions have been properly set.\n";
	exit(0);
}
print " >> Database was found!\n\n";
#### CONNECT TO MYSQL ####


my $TB_found="NO";
$sth = $master->{db}->{adcycle}->prepare("show tables"); 
$sth->execute;
while(@log = $sth->fetchrow_array){
	if($log[0] eq "login"){
		$TB_found="YES";
	}
}
if($TB_found eq "YES"){
	print "\n >> Old tables have been erased\n\n\n";
	$master->{tables}->erase_tables($master,"OUTPUT");
}


#### BUILD TABLES ####
print "Step 5. - Building Adcycle Tables\n\n";
$master->{tables}->create_tables($master);
print " >> Tables created.\n\n";
#### BUILD TABLES ####

print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>>>>>\n";
print ">>>>>>>>>>>\n";
print ">>>>>>>\n";
print ">>>\n";

print "\n\n** ADCYCLE SETUP IS COMPLETE **\n\n";
print ">> Scan the output above to see if any error messages were not identified by build\n";
print ">> A couple example campaigns have been added to your account. Delete them at any time.\n";
print ">> Delete build.cgi from your system. <<\n\n\n";
print qq~
Quick Setup Instructions
1. Login at $cgi_bin_url\/adcenter.cgi from the web.
   (Check your web server error log file if you get error messages.)
2. In the admin area, create an advertiser.
3. Add a couple campaigns for that advertiser with the same ad type.
4. Add a group with the same ad type as the campaigns.
5. Edit the group, and select the campaigns for the group rotation.
6. From the group page, grab an ad code for the group and paste it into a webpage.
7. View the webpage with a browser, and you should see the ads rotate on reloads. :)
\n~;
$master->{db}->{adcycle}->disconnect;


# Copyright (c) 2009 AdCycle.com All rights reserved.
# http://www.adcycle.com - download the lastest version of adcycle